---
title: IDBObjectStore.getAll()
slug: Web/API/IDBObjectStore/getAll
tags:
  - API
  - Database
  - IDBObjectStore
  - IndexedDB
  - Method
  - Reference
  - Storage
  - getAll
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>getAll()</code></strong> method of the {{domxref("IDBObjectStore")}} interface returns an {{domxref("IDBRequest")}} object containing all objects in the object store matching the specified parameter or all objects in the store if no parameters are given.</p>
</div>

<p>If a value is successfully found, then a structured clone of it is created and set as the result of the request object.</p>

<p>This method produces the same result for:</p>

<ul>
 <li>a record that doesn't exist in the database</li>
 <li>a record that has an undefined value</li>
</ul>

<p>To tell these situations apart, you either call</p>

<ol>
 <li>the {{domxref("IDBObjectStore.openCursor","openCursor()")}} method with the same key. That method provides a cursor if the record exists, and no cursor if it does not.</li>
 <li>the {{domxref("IDBObjectStore.count","count()")}} method with the same key, which will return 1 if the row exists and 0 if it doesn't.</li>
</ol>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var request = <em>objectStore</em>.getAll<em>(</em>);
var request = <em>objectStore</em>.getAll(<em>query</em>);
var request = <em>objectStore</em>.getAll(<em>query</em>, <em>count</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>query</em> {{optional_inline}}</dt>
 <dd>A key or {{domxref("IDBKeyRange")}} to be queried. If nothing is passed, this will default to a key range that selects all the records in this object store.</dd>
 <dt><em>count</em> {{optional_inline}}</dt>
 <dd>Specifies the number of values to return if more than one is found. If it is lower than <code>0</code> or greater than <code>2<sup>32</sup>-1</code> a {{jsxref("TypeError")}} exception will be thrown.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBObjectStore")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>The key or key range provided contains an invalid key or is null.</p>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBObjectStore")}} has been deleted or removed.<br>
     </td>
  </tr>
 </tbody>
</table>

<p>A {{jsxref("TypeError")}} exception is thrown if the <code>count</code> parameter is not between <code>0</code> and <code>2<sup>32</sup>-1</code> included.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB 2', '#dom-idbobjectstore-getall', 'getAll()')}}</td>
   <td>{{Spec2('IndexedDB 2')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBObjectStore.getAll")}}</p>
</div>


<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
